openerp.pagare_decorart = function (instance, local) {
    local.widgetInstance = null;
    local.parentInstance = null;

    local.PagareDecorartWidget = instance.Widget.extend({
        template : "pagare_decorart.PagareDecorart",
        jsonDoc:[],

        init:function(parent){
            this._super(parent);
        },

        updateId : function(id){
            var self = this;
            self.id=id;
        },

        start: function () {
            var self = this;
            this.$el.click(function (e) {
                self.fecthInitial();
            });
        },

        valorNull:function(dato){
            var valor ="";
            if (dato){
                if(dato == true && typeof dato == 'boolean'){
                    valor=" ";
                }else{
                    valor=dato;
                }
            }
            return valor;
        },

        fecthInitial: function(){
            var id= openerp.webclient._current_state.id;
            var self = this;
            self.fetchAccountInvoice(id).then(function(AccountInvoice){
                return AccountInvoice;
            }).then(function(AccountInvoice){
                self.AccountInvoice = AccountInvoice;
                return self.fetchAccountInvoiceQuota(id);
            }).then(function(AccountInvoiceQuota){
                self.AccountInvoiceQuota = AccountInvoiceQuota;
                return self.fetchAccountInvoiceLine();
            }).then(function(AccountInvoiceLine){
                self.AccountInvoiceLine = AccountInvoiceLine;
                return self.drawPDF();
            });
            return false;
        },

        fetchAccountInvoice: function(id){
            var domain=[['id','=', id]];
            var AccountInvoice = new instance.web.Model('account.invoice');
            return AccountInvoice.call('getAccountInvoicePagare',[domain], {
                context: new instance.web.CompoundContext()
            });
        },

        fetchAccountInvoiceQuota: function(id){
            var domain=[['id','=', id]];
            var AccountInvoice = new instance.web.Model('account.invoice');
            return AccountInvoice.call('getAccountInvoicePagareQuota',[domain], {
                context: new instance.web.CompoundContext()
            });
        },

        fetchAccountInvoiceLine: function () {
            var self = this;
            var invoice_ids = _.flatten(_.map(self.AccountInvoice,function(map){
                return map.id;
            }));
            var domain=[['invoice_id','in',invoice_ids]];
            var AccountInvoiceLine = new instance.web.Model('account.invoice.line');
            return AccountInvoiceLine.call('getAccountInvoiceLinePagare',[domain], {
                context: new instance.web.CompoundContext()
            });
        },

        drawPDF:function(){
            var self = this;
            var AccountInvoice = self.AccountInvoice;
            var CurrencyBase = self.AccountInvoice[0].currency_id[0];
            var docItem = [];
            var docQuotaItem = [];
            var getColumns = [];
            var getColumnsQuota = [];

            var pdfDoc = new jsPDF("p","mm","a4");

            // pdfDoc.page=1;

            pdfDoc.addImage("data:image/png;base64," + AccountInvoice[0].company_id[0].logo, 'png', 10, 10, 50, 30);

            _.each(self.AccountInvoiceLine, function(item){
                docItem.push({
                    name : item.name,
                    quantity : item.quantity,
                    price_unit : accounting.formatMoney(item.price_unit,'',CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    price_subtotal : accounting.formatMoney(item.price_subtotal,'',CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                });
            });
            getColumns.push({
                title : 'Descripción',
                halign: 'center',
                dataKey: 'name'
            });
            getColumns.push({
                title : 'Cantidad',
                halign: 'center',
                dataKey: 'quantity'
            });
            getColumns.push({
                title : 'P. Unitario',
                halign: 'center',
                dataKey: 'price_unit'
            });
            getColumns.push({
                title : 'Subtotal',
                halign: 'center',
                dataKey: 'price_subtotal'
            });

            pdfDoc.autoTable(getColumns, docItem, {
                theme: 'grid',
                styles: {
                    overflow: 'linebreak',
                    columnWidth: 'auto',
                    fontSize: 7
                },
                headerStyles: {
                    textColor: 20,
                    fillColor: null,
                    lineWidth: 0.1,
                    fontSize: 9
                },
                columnStyles: {
                    name : {columnWidth: 'auto'},
                    quantity : {columnWidth: 25, halign:'right'},
                    price_unit : {columnWidth: 25, halign:'right'},
                    price_subtotal : {columnWidth: 25, halign:'right'},
                },

                margin: { top: 200, horizontal: 10},

                addPageContent: function (data) {


                    pdfDoc.addImage("data:image/png;base64," + AccountInvoice[0].company_id[0].logo, 'png', 10, 10, 50, 30);

                    pdfDoc.setFontSize(11);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(20);
                    pdfDoc.text(80, 25,'SOLICITUD DE LINEA DE CREDITO');

                    pdfDoc.text(91, 30,'Empresa: MyS Decorart');
                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.rect(10, 45, 95, 7, 'S');
                    pdfDoc.text(12,50,'SUCURSAL: ' );
                    pdfDoc.rect(105, 45, 95, 7, 'S');
                    pdfDoc.text(110,50,'Fecha de Operación: ' + moment(AccountInvoice[0].date_invoice).format('DD/MM/YYYY'));
                    pdfDoc.rect(10, 55, 95, 7, 'S');
                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.text(12,60,'Vendedor: ' + AccountInvoice[0].user_name);
                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.rect(105, 55, 95, 7, 'S');
                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.text(110,60,'Número de Operación: ' + AccountInvoice[0].origin + ' ' +AccountInvoice[0].number);
                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(10, 70,'Datos del Cliente o Empresa');

                    // Cuadro principal
                    pdfDoc.rect(10, 76, 105 , 7, 'S');
                    // Cuadro fecha de emision
                    pdfDoc.rect(10, 76, 105, 7, 'S');
                    pdfDoc.setFontSize(8);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(20);
                    pdfDoc.text(12, 80,'Fecha de emisión: ');
                    pdfDoc.text(45, 80,  moment(AccountInvoice[0].date_invoice).format('DD/MM/YYYY'));
                    // RUC / Documento de identidad No.
                    pdfDoc.rect(115, 76, 90, 7, 'S');
                    pdfDoc.text(120, 80,'RUC / Doc. de Identidad No.: ' + AccountInvoice[0].partner_id[0].ruc);
                    // Nombre o Razon Social
                    pdfDoc.rect(10, 83, 105, 7, 'S');
                    pdfDoc.text(12, 88,'Nombre o Razón Social: ' + AccountInvoice[0].partner_id[0].name);
                    // Telefono
                    pdfDoc.rect(115, 83, 90, 7, 'S');
                    pdfDoc.text(120, 88,'Teléfono: ' + self.valorNull(AccountInvoice[0].partner_id[0].phone));

                    // Direccion
                    pdfDoc.rect(10, 90, 105, 7, 'S');
                    pdfDoc.text(12, 94,'Direccion: ' + self.valorNull(AccountInvoice[0].partner_id[0].address));

                    // celular
                    pdfDoc.rect(115, 90, 90, 7, 'S');
                    pdfDoc.text(120, 94,'Celular: ' + self.valorNull(AccountInvoice[0].partner_id[0].mobile));

                    // Direccion
                    pdfDoc.rect(10, 97, 105, 7, 'S');
                    pdfDoc.text(12, 101,'Barrio: ' + self.valorNull(AccountInvoice[0].partner_id[0].barrio));

                    // celular
                    pdfDoc.rect(115, 97, 90, 7, 'S');
                    pdfDoc.text(120, 101,'Ciudad: ' + self.valorNull(AccountInvoice[0].partner_id[0].city));

                    // Direccion
                    pdfDoc.rect(10, 104, 105, 7, 'S');
                    pdfDoc.text(12, 108,'Estado Civil: ' + self.valorNull(AccountInvoice[0].partner_id[0].estado_civil));

                    // celular
                    pdfDoc.rect(115, 104, 90, 7, 'S');
                    pdfDoc.text(120, 108,'Email: ' + self.valorNull(AccountInvoice[0].partner_id[0].email));

                    var tipo;
                    if(AccountInvoice[0].partner_id[0].casa_propia == true){
                           tipo = "Vivienda Propia";
                       }else{
                           tipo = "Vivienda Alquilada";
                    }
                    // TIPO DE VIVIENDA
                    pdfDoc.rect(10, 111, 105, 7, 'S');
                    pdfDoc.text(12, 115,'Tipo de Vivienda: ' + self.valorNull(tipo));

                    // celular
                    pdfDoc.rect(115, 111, 90, 7, 'S');
                    // pdfDoc.text(120, 100,'Vivienda Alquilada: ' + self.valorNull(AccountInvoice[0].partner_id[0].casa_alquiler));

                    // Direccion
                    pdfDoc.rect(10, 118, 105, 7, 'S');
                    pdfDoc.text(12, 122,'Empresa o Lugar de Trabajo: ' + self.valorNull(AccountInvoice[0].partner_id[0].trab_empresa));

                    // celular
                    pdfDoc.rect(115, 118, 90, 7, 'S');
                    pdfDoc.text(120, 122,'Teléfono: ' + self.valorNull(AccountInvoice[0].partner_id[0].trab_telefono));

                    // Direccion
                    pdfDoc.rect(10, 125, 105, 7, 'S');
                    pdfDoc.text(12, 129,'Dirección: ' + self.valorNull(AccountInvoice[0].partner_id[0].trab_street));

                    // celular
                    pdfDoc.rect(115, 125, 90, 7, 'S');
                    pdfDoc.text(120, 129,'Ciudad: ' + self.valorNull(AccountInvoice[0].partner_id[0].trab_city));

                    // Direccion
                    pdfDoc.rect(10, 132, 105, 7, 'S');
                    pdfDoc.text(12, 136,'Cargo: ' + self.valorNull(AccountInvoice[0].partner_id[0].trab_cargo));

                    // celular
                    pdfDoc.rect(115, 132, 90, 7, 'S');
                    pdfDoc.text(120, 136,'Antiguedad: ' + self.valorNull(AccountInvoice[0].partner_id[0].trab_antiguedad_a) + ',' + self.valorNull(AccountInvoice[0].partner_id[0].trab_antiguedad_m));

                    // salario
                    pdfDoc.rect(10, 139, 105, 7, 'S');
                    pdfDoc.text(12, 143,'Salario: ' + self.valorNull(AccountInvoice[0].partner_id[0].trab_salario));

                    // ref
                    // pdfDoc.rect(105, 133, 95, 7, 'S');
                    // pdfDoc.text(125, 137,'Vivienda Alquilada: ' + self.valorNull(AccountInvoice[0].partner_id[0].casa_alquiler));

                    pdfDoc.setFontSize(8);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.text(12,150,'Referencias Comerciales:');

                    i=0;
                    _.each(AccountInvoice[0].partner_id[0].ref_comercial_ids,function(item){
                        pdfDoc.setFontSize(8);
                        pdfDoc.setFontStyle('normal');
                        pdfDoc.text(12+i,155, '' + item.name);
                        pdfDoc.text(55+i,155, '' + item.phone);
                        i=95;
                    });

                    pdfDoc.setFontSize(8);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.text(12,178,'Referencias Personales:');

                    i=0;
                    _.each(AccountInvoice[0].partner_id[0].ref_personal_ids,function(item){
                        pdfDoc.setFontSize(8);
                        pdfDoc.setFontStyle('normal');
                        pdfDoc.text(12+i,182, '- ' + item.email);
                        pdfDoc.text(30+i,182, '' + item.name);
                        pdfDoc.text(65+i,182, '' + item.phone);
                        i=95;

                    });

                pdfDoc.setFontSize(10);
                pdfDoc.setFontStyle('bold');
                pdfDoc.setTextColor(40);
                pdfDoc.text(85,195,'ESPECIFICACIÓN DE VENTAS ');


                // function footer(){
                //     pdfDoc.text(150,285, 'page ' + doc.page);
                //     pdfDoc.page ++;
                // };

                }
            });


            _.each(self.AccountInvoiceQuota, function(item){
                docQuotaItem.push({
                    date : moment(item.date).format('DD/MM/YYYY'),
                    name : item.name,
                    amount : accounting.formatMoney(item.amount,'',CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                });
            });
            getColumnsQuota.push({
                title : 'Fecha',
                halign: 'center',
                dataKey: 'date'
            });
            getColumnsQuota.push({
                title : 'Descripción',
                halign: 'center',
                dataKey: 'name'
            });
            getColumnsQuota.push({
                title : 'Valor de la Cuota',
                halign: 'center',
                dataKey: 'amount'
            });


           var finalY = pdfDoc.autoTable.previous.finalY;

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('bold');
            pdfDoc.setTextColor(40);
            pdfDoc.text(10,finalY + 5,'Total: ' + accounting.formatMoney(AccountInvoice[0].amount_total,CurrencyBase.symbol,CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator));

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('bold');
            pdfDoc.text(10,finalY + 10,'Firma del cliente: _ _ _ _ _ _ _ _ _ _       Aclaración: _ _ _ _ _ _ _ _ _ _               C.I.N°: _ _ _ _ _ _ _');



            pdfDoc.addPage();
            var finalY2 = 20
            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('bold');
            pdfDoc.setTextColor(40);
            pdfDoc.text(85,finalY2 ,'Información de Cuotas ');

            // var finalY2 = pdfDoc.autoTable.previous.finalY;

            pdfDoc.autoTable(getColumnsQuota, docQuotaItem, {
                theme: 'grid',
                startY: finalY2 + 5,
                styles: {
                    overflow: 'linebreak',
                    columnWidth: 'auto',
                    fontSize: 7,

                },
                headerStyles: {
                    textColor: 20,
                    fillColor: null,
                    lineWidth: 0.1,
                    fontSize: 9
                },
                columnStyles: {
                    date : {columnWidth: 'auto', halign: 'center'},
                    name : {columnWidth: 'auto', halign: 'center'},
                    amount : {columnWidth: 'auto', halign: 'right'}
                },
                margin: {horizontal: 10},
                addPageContent: function (data) {
                    // pdfDoc.setFontSize(10);
                    // pdfDoc.setFontStyle('bold');
                    // pdfDoc.setTextColor(40);
                    // pdfDoc.text(85,finalY + 15,'Información de Cuotas ');
                    //
                    // pdfDoc.setFontSize(10);
                    // pdfDoc.setFontStyle('bold');
                    // pdfDoc.setTextColor(40);
                    // pdfDoc.text(10,finalY + 5,'Total: ' + accounting.formatMoney(AccountInvoice[0].amount_total,CurrencyBase.symbol,CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator));
                }
            });



            var finalY2 = pdfDoc.autoTable.previous.finalY;


            finalY2 +=5
            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('bold');
            pdfDoc.setTextColor(40);
            pdfDoc.text(10,finalY2,'Total: ' + accounting.formatMoney(AccountInvoice[0].amount_total,CurrencyBase.symbol,CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator));

            finalY2 +=5
            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('bold');
            pdfDoc.text(10,finalY2,'Firma del cliente: _ _ _ _ _ _ _ _ _ _       Aclaración: _ _ _ _ _ _ _ _ _ _               C.I.N°: _ _ _ _ _ _ _');
            

            pdfDoc.addPage();

            var finalY2 = 20
            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('normal');
            var paragraph= "En ciertas condiciones de venta y bajo el criterio de la empresa, el cheque diferido  no se tomara como pago efectivo (no tendrá emisión de recibo) y se tomara como garantia de pago hasta su cobro efectivo con la respectiva emisión del recibo de pago.";
            pdfDoc.text(paragraph,10,finalY2,{maxWidth:188,align:'justify'});

            finalY2 +=20
            var paragraph= "Por el presente instrumento le(s) autorizo(amos) de forma expresa e irrevocable, otorgando suficiente mandato en los términos de los Art. 917 inc. A del Código Civil Paraguayo, para que por propia cuenta o a través empresas especializadas de nuestro medio, puedan recabar información en plaza referente a mi(nuestra) situación patrimonial solvencia económica, o el cumplimiento de nuestras obligaciones comerciales, así como también a la verificación confirmación y/o certificación de los datos por mi(nosotros) proveídos a fin de que puedan contar con los elementos de juicio y análisis necesarios para la concesión del crédito que me(nos) encuentro(amos) gestionando ante LA EMPRESA MyS Decorart del grupo Líder Constructora. De igual manera, en los mismos términos le(s) autorizo(amos) para que en caso de un atraso superior a los 90 días en el pago del presente crédito o de cualquier otra deuda pendiente que mantenga(mos) con esa empresa, incluyan mi(nuestro) nombre personal o Razón Social que represento(amos) en en Registro General de Morosos de INFORMCONF o de cualquier otra entidad encargada para tales efectos, como así también, proporcionar esa información a terceros interesados. La eliminación de dicho registro se realizará de acuerdo a los términos establecidos en la Ley 1.682 y sus modificaciones. De igual manera reconozco(emos) y acepto(amos) que la EMPRESA MyS Decorart del Grupo Líder Constructora podrá ceder sus derechos derivados del presente contrato y de los pagares de la deuda ya sea mediante una cesión de derechos o venta de cartera o cualquier otra forma permitida por la ley a lo que presto(amos) desde ahora y por le presente documento consentimiento expreso e irrevocable a dichas cesiones y transferencias incluyendo las correspondientes garantías que se pudieren haber constituido a favor de LA EMPRESA, en respaldo de las obligaciones. LA EMPRESA MyS Decorart del grupo Líder Constructora puede transferir a terceros, de manera total o parcial, sus derechos y obligaciones emergentes del Contrato.";
            pdfDoc.text(paragraph,10,finalY2,{maxWidth:188,align:'justify'});

            finalY2 +=80
            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('bold');
            pdfDoc.text(12,finalY2,'PLANO DE UBICACIÓN DEL NEGOCIO/DOMICILIO:');

            finalY2 +=5
            // ref
            pdfDoc.rect(12, finalY2, 15, 15, 'S');

            // ref
            pdfDoc.rect(35, finalY2, 15, 15, 'S');

            // ref
            pdfDoc.rect(58, finalY2, 15, 15, 'S');

            // ref
            pdfDoc.rect(118, finalY2, 15, 15, 'S');

            // ref
            pdfDoc.rect(141, finalY2, 15, 15, 'S');

            // ref
            pdfDoc.rect(164,finalY2, 15, 15, 'S');

            finalY2 +=20
            // ref
            pdfDoc.rect(12, finalY2, 15, 15, 'S');
            //
            // // ref
            pdfDoc.rect(35, finalY2, 15, 15, 'S');
            //
            // // ref
            pdfDoc.rect(58, finalY2, 15, 15, 'S');
            //
            //
            // ref
            pdfDoc.rect(118, finalY2, 15, 15, 'S');
            //
            // ref
            pdfDoc.rect(141, finalY2, 15, 15, 'S');
            //
            // ref
            pdfDoc.rect(164, finalY2, 15, 15, 'S');
            //
            finalY2 +=20
            // ref
            pdfDoc.rect(12, finalY2, 15, 15, 'S');

            // ref
            pdfDoc.rect(35, finalY2, 15, 15, 'S');
            //
            // ref
            pdfDoc.rect(58, finalY2, 15, 15, 'S');

            // ref
            pdfDoc.rect(118, finalY2, 15, 15, 'S');
            //
            // ref
            pdfDoc.rect(141, finalY2, 15, 15, 'S');
            //
            // ref
            pdfDoc.rect(164, finalY2, 15, 15, 'S');

            // finalY2 +=20
            // console.log(finalY2);
            // if (finaly2 > 220) {

               // pdfDoc.setFontSize(9);
               // pdfDoc.setFontStyle('bold');
               // var paragraph="Declaramos que los datos consignados en esta solicitud de MyS DECORART; son fiel reflejo de nuestra situación.";
               // pdfDoc.text(paragraph,12, 20,{maxWidth:188,align:'justify'});
               //
               // pdfDoc.setFontSize(9);
               // pdfDoc.setFontStyle('normal');
               // pdfDoc.setTextColor(40);
               // pdfDoc.text(12, 25,'Firma del Solicitante: _ _ _ _ _ _ _ _ _ _ _ _ _');
               //
               // pdfDoc.setFontSize(9);
               // pdfDoc.setFontStyle('normal');
               // pdfDoc.setTextColor(40);
               // pdfDoc.text(12, 30,'Aclaración de Firma y N° de C.I.N°: _ _ _ _ _ _ _ _ _ _ _ _');
               //
               // pdfDoc.setFontSize(9);
               // pdfDoc.setFontStyle('normal');
               // pdfDoc.setTextColor(40);
               // pdfDoc.text(12, 35,'Sello de la Empresa:');
            //
            // }

            // if (finaly2<220) {
                finalY2 +=20
                pdfDoc.setFontSize(9);
                pdfDoc.setFontStyle('bold');
                var paragraph="Declaramos que los datos consignados en esta solicitud de MyS DECORART; son fiel reflejo de nuestra situación.";
                pdfDoc.text(paragraph,12, finalY2,{maxWidth:188,align:'justify'});

                finalY2 +=10
                pdfDoc.setFontSize(9);
                pdfDoc.setFontStyle('normal');
                pdfDoc.setTextColor(40);
                pdfDoc.text(12, finalY2,'Firma del Solicitante: _ _ _ _ _ _ _ _ _ _ _ _ _');

                finalY2 +=10
                pdfDoc.setFontSize(9);
                pdfDoc.setFontStyle('normal');
                pdfDoc.setTextColor(40);
                pdfDoc.text(12, finalY2,'Aclaración de Firma y N° de C.I.N°: _ _ _ _ _ _ _ _ _ _ _ _');

                finalY2 +=10
                pdfDoc.setFontSize(9);
                pdfDoc.setFontStyle('normal');
                pdfDoc.setTextColor(40);
                pdfDoc.text(12, finalY2,'Sello de la Empresa:');
            // }





            // pdfDoc.addPage();
            // pdfDoc.setTextColor(40);
            // i=0
            // _.each(self.AccountInvoiceQuota, function(item){
            //
            // pdfDoc.setFontSize(14);
            // pdfDoc.setFontStyle('bold');
            // pdfDoc.text(80,15+i,'MyS DECORART');
            // pdfDoc.setFontSize(12);
            // pdfDoc.setFontStyle('bold');
            // pdfDoc.rect(10, 18+i, 95, 0, 'S');
            // pdfDoc.text(12,23+i,'Número de Operación:' + AccountInvoice[0].origin);
            // pdfDoc.setFontSize(12);
            // pdfDoc.setFontStyle('bold');
            // pdfDoc.rect(105, 18+i, 95, 0, 'S');
            // pdfDoc.text(110,23+i,'Fecha de Operación: ' + moment(AccountInvoice[0].date_invoice).format('DD/MM/YYYY'));
            // pdfDoc.setFontSize(12);
            // pdfDoc.setFontStyle('bold');
            // pdfDoc.text(12,28+i,'C.I. N°: ' + self.valorNull(AccountInvoice[0].partner_id[0].ruc));
            // pdfDoc.setFontSize(12);
            // pdfDoc.setFontStyle('bold');
            // pdfDoc.text(110,28+i,'Vendedor: ' + self.valorNull(AccountInvoice[0].user_name));
            // pdfDoc.setFontSize(12);
            // pdfDoc.setFontStyle('bold');
            // pdfDoc.text(12,33+i,'Cliente: ' + self.valorNull(AccountInvoice[0].partner_id[0].name));
            // pdfDoc.rect(10, 35+i, 95, 0, 'S');
            // pdfDoc.setFontSize(12);
            // pdfDoc.setFontStyle('bold');
            // pdfDoc.text(12,43+i,'Cuota N°:' + item.name);
            // pdfDoc.rect(105, 35+i, 95, 0, 'S');
            // pdfDoc.setFontSize(12);
            // pdfDoc.setFontStyle('bold');
            // pdfDoc.text(110,43+i,'Vence: ' + moment(item.date).format('DD/MM/YYYY'));
            // pdfDoc.setFontSize(12);
            // pdfDoc.setFontStyle('bold');
            // pdfDoc.text(12,49+i,'Monto Cuota:' + item.amount);
            // pdfDoc.setFontSize(12);
            // pdfDoc.setFontStyle('bold');
            // pdfDoc.text(110,56+i,'Firma: _ _ _ _ _ _ _ _ _');

              // i=i+55
              // if (i>220) {
              //    pdfDoc.addPage();
              //    i=0
              // }
            // });

            pdfDoc.addPage();

            pdfDoc.addImage("data:image/png;base64," + AccountInvoice[0].company_id[0].logo, 'png', 10, 10, 50, 30);
            pdfDoc.setFontSize(16);
            pdfDoc.setFontStyle('bold');
            pdfDoc.setTextColor(40);
            pdfDoc.text(80,25,'PAGARE A LA ORDEN');

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('normal');
            pdfDoc.setTextColor(40);
            pdfDoc.rect(10, 45, 95, 7, 'S');
            pdfDoc.text(12,50,'Número de Operación: ' + AccountInvoice[0].origin);
            pdfDoc.rect(105, 45, 95, 7, 'S');
            pdfDoc.text(110,50,'Fecha de Operación: ' + moment(AccountInvoice[0].date_invoice).format('DD/MM/YYYY'));
            pdfDoc.rect(10, 55, 95, 7, 'S');
            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('normal');
            pdfDoc.text(12,60,'Monto a pagar: ' + accounting.formatMoney(AccountInvoice[0].amount_total,CurrencyBase.symbol,CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator));
            pdfDoc.rect(105, 55, 95, 7, 'S');
            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('normal');
            _.each(self.AccountInvoiceQuota, function(item){
                varfecha=item.date;
            });
            pdfDoc.text(110,60,'Vencimiento: ' + moment(varfecha).format('DD/MM/YYYY'));
            var total_in_letters = instance.web.num2word(AccountInvoice[0].amount_total);
            pdfDoc.rect(10, 65, pdfDoc.internal.pageSize.getWidth() - 15 , 16,'S');
            pdfDoc.setFontSize(11);
            pdfDoc.setFontStyle('normal');
            pdfDoc.text(12,70,'Pagaré a la orden de M&S Decorart del grupo Líder Constructora.');
            pdfDoc.setFontSize(10.5);
            pdfDoc.setFontStyle('normal');
            pdfDoc.text(12,75,'La suma de Guaraníes: ' );
            pdfDoc.setFontSize(10.5);
            pdfDoc.setFontStyle('bold');
            pdfDoc.text(12,79, total_in_letters);
            pdfDoc.rect(10, 81, pdfDoc.internal.pageSize.getWidth() - 15 , 60,'S');
            pdfDoc.setFontSize(11);
            pdfDoc.setFontStyle('normal');
            var paragraph="Queda expresamente convenido que la falta de pago de este pagaré me (nos) constituirá en mora automáticamente, sin necesidad de interpelación judicial o extrajudicial alguna, devengando durante el tiempo de la mora un interés del ....%, un interés moratorio del ....% y una comisión del ....% por el simple retardo sin que esto implique prórroga del plazo de la obligación. Asimismo me (nos) obligamos a pagar cualquier gasto en que incurra el acreedor con relación a este préstamo, en caso de que el mismo sea reclamado por la vía judicial o extrajudicial. El simple vencimiento establecerá mora, autorizando la inclusión de nombre personal o Razón Social que represento, a la base de datos de Informconf, conforme a lo establecido en la Ley 168/01, como también para que se pueda proveer la información a terceros interesados. A los efectos legales y procesales nos sometemos a la jurisdicción de los Tribunales de Ciudad del Este y renunciando a cualquier otra que pudiera corresponder las partes constituyen domicilio real y especial en los lugares señalados en el presente documento.";
            pdfDoc.text(paragraph,12,87,{maxWidth:188,align:'justify'});

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('bold');
            pdfDoc.setTextColor(40);
            pdfDoc.text(10,165,'DEUDOR');
            pdfDoc.text(120,165,'CO-DEUDOR');

            pdfDoc.setFontSize(9);
            pdfDoc.setFontStyle('normal');
            pdfDoc.setTextColor(40);
            pdfDoc.text(10,175,'Nombre y Apellido: ' + AccountInvoice[0].partner_id[0].name);
            pdfDoc.text(120,175,'Nombre y Apellido:');
            pdfDoc.text(10,180,'RUC / DNI: ' + self.valorNull(AccountInvoice[0].partner_id[0].ruc));
            pdfDoc.text(120,180,'RUC / DNI:');
            pdfDoc.text(10,185,'Domicilio: ' + self.valorNull(AccountInvoice[0].partner_id[0].address));
            pdfDoc.text(120,185,'Domicilio:');
            pdfDoc.text(10,195,'Telefono: ' + self.valorNull(AccountInvoice[0].partner_id[0].phone));
            pdfDoc.text(120,195,'Telefono:');
            pdfDoc.text(10,200,'Celular: ' + self.valorNull(AccountInvoice[0].partner_id[0].mobile));
            pdfDoc.text(120,200,'Celular:');
            pdfDoc.text(10,210,'Firma: ');
            pdfDoc.text(120,210,'Firma:');


            pdfDoc.save('pagare.pdf');
        },
    });
    if (instance.web && instance.web.FormView) {
        instance.web.FormView.include({
            load_form: function (record) {
                this._super.apply(this, arguments);
                if (this.model !== 'account.invoice') return;
                local.parentInstance = this;
                if (local.widgetInstance) {
                    local.widgetInstance.updateId(record.id);
                }
                local.widgetInstance = new local.PagareDecorartWidget(this);
                var elemento = this.$el.find('.oe_form').find('.pagare_button_box');
                local.widgetInstance.appendTo(elemento);
                local.widgetInstance.updateId(record.id);
            }
        });
    }
};
